<?php

namespace App\Filament\Exports;

use App\Models\WorkGroupMaster;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class WorkGroupMasterExporter extends Exporter
{
    protected static ?string $model = WorkGroupMaster::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.name')
            ->label('PLANT'),
            ExportColumn::make('name')
            ->label('NAME'),
            ExportColumn::make('description')
            ->label('DESCRIPTION'),
            ExportColumn::make('operation_number')
            ->label('OPERATION NUMBER'),
            ExportColumn::make('created_by')
            ->label('CREATED BY'),
            ExportColumn::make('created_at')
            ->label('CREATED AT'),
            ExportColumn::make('updated_at')
            ->label('UPDATED AT'),
            ExportColumn::make('deleted_at')
            ->label('DELETED AT')
            ->enabledByDefault(false),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your work group master export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
